# [MonoGame](http://monogame.net/) <a href='http://monogame.net/' target='_blank'><img src='https://github.com/mono/MonoGame/blob/develop/Graphics/Logos/MonogameLogo32x32.png?raw=true' width='16' height='16'></a> [![Build Status](http://build.monogame.net/job/develop-win/badge/icon)](http://build.monogame.net/job/develop-win/)

[MonoGame](http://monogame.net) is an open source implementation of the Microsoft XNA 4.x Framework. 

Our goal is to make it easy for XNA developers to create cross-platform games with extremely high code reuse.

## Supported Platforms

* iOS (including Retina displays)
* Android
* Windows (OpenGL, a DirectX 11 version is currently in development)
* Mac OS X
* Linux
* [Windows Store Apps](http://dev.windows.com) (for Windows 8 and Windows RT)
* [Windows Phone 8](http://dev.windowsphone.com)
* [PlayStation Mobile](https://psm.playstation.net/portal/en/index.html) (currently 2D only)
* [OUYA](http://ouya.tv), an Android-based gaming console

## Quick Start

There are a few pre-requisites that you should be aware of for the various platforms. Please check them over [MonoGame](http://monogame.net/downloads) website.

There are three quick start options available:
* Download the latest stable release over [our website](http://monogame.net/downloads).
* Download the latest [source code](https://github.com/mono/MonoGame/archive/develop.zip).
* Clone the repo: `https://github.com/mono/MonoGame.git`.

## Bug Tracker

Have a bug or a feature request? [Please open a new issue](https://github.com/mono/MonoGame/issues). Before opening any issue, please search for existing issues and read the [Issue Guidelines](https://github.com/necolas/issue-guidelines).

## Community

Keep track of development and community news.

* Follow [@MonoGameTeam on Twitter](https://twitter.com/monogameteam).
* Have a question that's not a feature request or bug report? [Ask on our discussions list.](http://monogame.codeplex.com/discussions)
* Join us over IRC - [irc://irc.gnome.org/#monogame](http://mibbit.com/?server=irc.gnome.org&channel=%23monogame). 

## Contributing

Please read our [contributing](https://github.com/mono/MonoGame/blob/develop/CONTRIBUTING.md) guide.

## License

MonoGame is released under [Microsoft Public License (Ms-PL)](https://github.com/mono/MonoGame/blob/develop/LICENSE.txt).

## Current Roadmap

* The MonoGame 2.x series is now in maintenance mode.
* MonoGame 3.0 will mark the start of full support for the entire XNA API.
* The Content Pipeline is currently under development. This will allow compiling of assets to optimized formats for the MonoGame supported platforms in Visual Studio or MonoDevelop without requiring XNA Game Studio 4.0 installed.
* SuperGiant Games have a version working in Google Chrome Native Client which we will merge back into our tree.
* Raspberry Pi has been shown to be working, but still needs some work.
